/*
    Title : PCCOM/RISCOM Sample Program -- DECESION TAIWAN
    Author : Charming, T.M. Chen
    Date   : 01/20/96
    PlatForm : OS/2 2.1 with BC-OS/2 2.0 on PC 486
*/
#define INCL_DOSFILEMGR		/* File System Value */
#define INCL_DOSPROCESS		/* Process and Threads Value */
#define INCL_DOSDEVICES		/* Device Value */
#define	INCL_DOSDEVIOCTL	/* Device IOCTL	Value */
#include <os2.h>		/* General OS/2 include file */
#include <stdio.h>              /* Standard IO include file */
#include <stdlib.h>		/* Standard LIB include file */

HFILE  hfile;			/* File	Handle for the device */
UCHAR  ucStatus;		/* The COM port	stauts byte */
ULONG  ulStatusLen;		/* Length of Stauts(data packet) */
ULONG  ulAction;		/* Action taken	by DosOpen */
APIRET rc;			/* Return Code */

#define ASYNC_EXTSETBAUDRATE  0x43
#define	ASYNC_EXTGETBAUDRATE  0x63

typedef struct _EXTBAUDRATE {
	ULONG freq;
	BYTE fraction;
	} EXTBAUDRATE;
typedef EXTBAUDRATE FAR * PEXTBAUDRATE;
/*------------------------------------------------------------------------*/
int     SetBaudRate( PEXTBAUDRATE pbaudrate, HFILE HfCom )
{
	ULONG ParmLength = sizeof (*pbaudrate);
	return DosDevIOCtl(HfCom,
		IOCTL_ASYNC ,
		ASYNC_EXTSETBAUDRATE ,
		( PVOID ) pbaudrate ,
		ParmLength,
		&ParmLength,
		( PVOID ) NULL ,
		( ULONG ) 0,
		( PVOID ) NULL
		) ;
}
/*------------------------------------------------------------------------*/
int     GetBaudRate( PEXTBAUDRATE pbaudrate, HFILE HfCom )
{
	ULONG DataLength = sizeof (*pbaudrate);
	return DosDevIOCtl(HfCom,
		IOCTL_ASYNC ,
		ASYNC_EXTGETBAUDRATE ,
		( PVOID ) NULL ,
                ( ULONG ) 0,
		( PVOID ) NULL,
                ( PVOID ) pbaudrate ,
                DataLength,
                &DataLength
		) ;
}
/*------------------------------------------------------------------------*/
void main(argc, argv)
int    argc;
char *argv[];
{
     EXTBAUDRATE  BaudRate ={9600 ,0};

     if	( argc != 3 ) {
	printf("Usage :	SetBaud	Comn BaudRate\n");
	DosExit(EXIT_PROCESS, 1);
     }
     if	( (rc=DosOpen(argv[1], &hfile, &ulAction, 0, FILE_NORMAL, FILE_OPEN,
	OPEN_ACCESS_READWRITE | OPEN_SHARE_DENYNONE, (PEAOP2)NULL) ) != 0 ) {
	printf("%s open fail with return code %d.\n", argv[1], rc);
	DosExit(EXIT_PROCESS, 2);
     }
     BaudRate.freq = atoi(argv[2]);
     if	( ( rc = SetBaudRate((PEXTBAUDRATE)&BaudRate, hfile) ) != 0 ) {
	printf("%s set baudrate fail with return code %d.\n", argv[1], rc);
	DosExit(EXIT_PROCESS, 3);
     }
     if	( ( rc = GetBaudRate((PEXTBAUDRATE)&BaudRate, hfile) ) != 0 ) {
	printf("%s get baudrate fail with return code %d.\n", argv[1], rc);
	DosExit(EXIT_PROCESS, 4);
     }
     if	( ( rc = DosClose(hfile) ) != 0	) {
	printf("%s close fail with return code %d.\n", argv[1], rc);
	DosExit(EXIT_PROCESS, 5);
     }
     printf("The BaudRate of %s	is set to %d\n", argv[1], BaudRate.freq);
     DosExit(EXIT_PROCESS, 0);
}
